%define ovs_version 2.11
%define epoch 1

Name:           rhv-openvswitch
Version:        %{ovs_version}
Release:        5%{?dist}
Epoch:          %{epoch}
Summary:        Wrapper RPM for upgrading OVS to newer versions

Group:          System Environment/Daemons
License:        Public Domain
URL:            http://www.openvswitch.org
BuildArch:      noarch

Requires:       openvswitch%{ovs_version}
Provides:       openvswitch = %{epoch}:%{ovs_version}
Obsoletes:      openvswitch < %{epoch}:%{ovs_version}
Obsoletes:      openvswitch-dpdk < %{epoch}:%{ovs_version}
Obsoletes:      openvswitch2.10 < %{epoch}:%{ovs_version}

%description
Wrapper rpm for the openvswitch package

%package -n     rhv-python-openvswitch
Summary:        Wrapper for python-openvswitch rpm
License:        Public Domain
Requires:       python-openvswitch%{ovs_version}
Provides:       python-openvswitch = %{epoch}:%{ovs_version}
Provides:       python2-openvswitch = %{epoch}:%{ovs_version}
Obsoletes:      python-openvswitch < %{epoch}:%{ovs_version}
Obsoletes:      python-openvswitch2.10 < %{epoch}:%{ovs_version}

%description -n rhv-python-openvswitch
Wrapper rpm for the base python-openvswitch package

%package        devel
Summary:        Wrapper for openvswitch-devel rpm
License:        Public Domain
Requires:       openvswitch%{ovs_version}-devel
Provides:       openvswitch-devel = %{epoch}:%{ovs_version}
Obsoletes:      openvswitch-devel < %{epoch}:%{ovs_version}
Obsoletes:      openvswitch2.10-devel < %{epoch}:%{ovs_version}

%description devel
Wrapper rpm for the base openvswitch-devel package

%package        ovn-central
Summary:        Wrapper for openvswitch-ovn-central rpm
License:        Public Domain
Requires:       ovn%{ovs_version}-central
Provides:       openvswitch-ovn-central = %{epoch}:%{ovs_version}
Obsoletes:      openvswitch-ovn-central < %{epoch}:%{ovs_version}
Obsoletes:      openvswitch2.10-ovn-central < %{epoch}:%{ovs_version}

%description ovn-central
Wrapper rpm for the base openvswitch-ovn-central package

%package        ovn-host
Summary:        Wrapper for openvswitch-ovn-host rpm
License:        Public Domain
Requires:       ovn%{ovs_version}-host
Provides:       openvswitch-ovn-host = %{epoch}:%{ovs_version}
Obsoletes:      openvswitch-ovn-host < %{epoch}:%{ovs_version}
Obsoletes:      openvswitch2.10-ovn-host < %{epoch}:%{ovs_version}

%description    ovn-host
Wrapper rpm for the base openvswitch-ovn-host package

%package        ovn-vtep
Summary:        Wrapper for openvswitch-ovn-vtep rpm
License:        Public Domain
Requires:       ovn%{ovs_version}-vtep
Provides:       openvswitch-ovn-vtep = %{epoch}:%{ovs_version}
Obsoletes:      openvswitch-ovn-vtep < %{epoch}:%{ovs_version}
Obsoletes:      openvswitch2.10-ovn-vtep < %{epoch}:%{ovs_version}

%description    ovn-vtep
Wrapper rpm for the base openvswitch-ovn-vtep package

%package        ovn-common
Summary:        Wrapper for openvswitch-ovn-common rpm
License:        Public Domain
Requires:       ovn%{ovs_version}
Provides:       openvswitch-ovn-common = %{epoch}:%{ovs_version}
Obsoletes:      openvswitch-ovn-common < %{epoch}:%{ovs_version}
Obsoletes:      openvswitch2.10-ovn-common < %{epoch}:%{ovs_version}

%description    ovn-common
Wrapper rpm for the base openvswitch-ovn-common package

%prep
# Nothing to prepare

%build
# Nothing to build

%install
# Nothing to install

%files
%files -n rhv-python-openvswitch
%files devel
%files ovn-central
%files ovn-host
%files ovn-vtep
%files ovn-common

%pretrans
preenabled_dir=/var/run/rhv-openvswitch/enabled
preactive_dir=/var/run/rhv-openvswitch/active
mkdir -p "$preenabled_dir" "$preactive_dir"
for service in openvswitch ovn-northd ovirt-provider-ovn ovn-controller; do
    if [ "$(systemctl is-enabled "$service")" = "enabled" ]; then
        touch "$preenabled_dir/$service"
    fi
    if [ "$(systemctl is-active "$service")" = "active" ]; then
        touch "$preactive_dir/$service"
    fi
done

%posttrans
preenabled_dir=/var/run/rhv-openvswitch/enabled
preactive_dir=/var/run/rhv-openvswitch/active
if [ -d "$preenabled_dir" ]; then
    for service in openvswitch ovn-northd ovirt-provider-ovn ovn-controller; do
        if [ -e "$preenabled_dir/$service" ]; then
            systemctl enable "$service"
            rm "$preenabled_dir/$service"
        fi
        if [ -e "$preactive_dir/$service" ]; then
            systemctl start "$service"
            rm "$preactive_dir/$service"
        fi
    done
fi

%changelog
* Thu Jun 20 2019 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1:2.11-5
- remove warning during install / update - fixes bz#1717056

* Mon Apr 29 2019 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1:2.11-3
- add the dist info to the release tag

* Mon Apr 22 2019 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1:2.11-2
- update OVN dependencies name
- obsolete openvswitch2.10 packages, enabling ovs2.10 => ovs2.11 upgrades

* Thu Mar 21 2019 Dan Kenigsberg <danken@redhat.com> - 1:2.10-4
- keep OVN enabled when upgrading from openvswitch-2.9 (rhbz#1690782)

* Mon Oct 15 2018 Miguel Duarte Barroso <mdbarroso@redhat.com> - 1:2.10-3
- Provide both python2-openvswitch and python-openvswitch dependencies

* Mon Oct 15 2018 Miguel Duarte Barroso <sbonazzo@redhat.com> - 1:2.10-2
- Update license

* Mon Sep 24 2018 Sandro Bonazzola <sbonazzo@redhat.com> - 1:2.10-1
- Initial import

